<?php
  session_start();
  require_once 'setup.php';

  $user_reset = new USER();


  if(isset($_GET['id']) && isset($_GET['code']))
  {
     $id = base64_decode($_GET['id']);
     $code = $_GET['code'];
     
     $stmt = $user_reset->runQuery("SELECT * FROM tbl_users WHERE userID=:uid AND tokenCode=:token");
       $stmt->execute(array(":uid"=>$id,":token"=>$code));
       $rows = $stmt->fetch(PDO::FETCH_ASSOC);
     
     if($stmt->rowCount() == 1)
     {
        if(isset($_POST['btn-reset-pass']))
        {
            $pass  = $_POST['pass'];
            $cpass = $_POST['confirm-pass'];
            $password = md5($cpass);

            $PWtest = trim(checkPWord($cpass))   ;

            if (!empty($PWtest))
            { $msg = $PWtest  ;
            }else
            {           
                 if($cpass!==$pass)
                 {
                    $msg = "Sorry!</strong>  Password Doesn't match." ;
                 }else // $cpass==$pass
                 {
                    $stmt = $user_reset->runQuery("UPDATE tbl_users SET userPass=:upass WHERE userID=:uid");
                    try
                    {
                      $stmt->execute(array(":upass"=>$password,":uid"=>$rows['userID']));
                      $msg = "Password Changed! <br />
                              <br />
                              <h4>Redirecting to Login Page ...</h4>" ;
                              header("refresh:5;".$MyDBLoginWiki);
                    }
                    catch(PDOException $ex)
                    { "Database UPDATE error:  ".$msg = $ex->getMessage(); }
                 }    // $cpass==$pass
            }
        }     // $_POST['btn-reset-pass']
     }else  //Couldn't Match ID and CODE
     { exit; }
  }else  // Not sure how you got here, so we send you back to the start...
  { $user_reset->redirect('index.php'); }



  function checkPWord($pwd) 
  {
      $errors = "";
      $pattern = '/[\'\/~`\!@#\$%\^&\*\(\)_\-\+=\{\}\[\]\|;:"\<\>,\.\?\\\]/';

      if ( strlen($pwd) < 8)                  { $errors .= "Password too short! (Minimum of 8 Characters)<br />"         ; }
      if (!preg_match("#[0-9]+#", $pwd))      { $errors .= "Password must include at least one number!<br />"            ; }
      if (!preg_match("#[a-z]+#", $pwd))      { $errors .= "Password must include at least one Lower-Case letter!<br />" ; }
      if (!preg_match("#[A-Z]+#", $pwd))      { $errors .= "Password must include at least one Upper-Case letter!<br />" ; }  
      if (!preg_match($pattern,   $pwd))      { $errors .= "Password must include at least one Special Character!<br />" ; }    

      return trim($errors);
  }    

?>


<!DOCTYPE html>
<html>
  <head>
    <title>Password Reset</title>
    <link rel="stylesheet"   href="login.css"  />
  </head>
  <body id="login">    
    <div class="container">
      <h1>Password Reset Page</h1>
      <div class='alert alert-success'>
        <h2><strong>Hello </strong>  <?php echo $rows['userName'] ?>!<br />
        <h3>        You are here to reset your forgetton password.</h3>
        </h2>
      </div>
      <hr />
          <div class="CommBox">
            <h3> <?php  if(isset($msg)) 
                        {  echo  $msg; 
                        }else
                        {  echo "Please Enter the New Password Twice";
                        } 
                 ?>                 
            </h3>
          </div>

      <form class="form-signin" method="post">
        <input  type="password" 
                class="input-block-level" 
                placeholder="New Password" 
                name="pass" 
                required
                size="25" /><br />
        <input  type="password" 
                class="input-block-level" 
                placeholder="Confirm New Password" 
                name="confirm-pass" 
                required
                size="25" /><br />
                <h3>Password Rules - at least 8 characters, Upper-Case & Lower-Case, and a <br />
                Special Character: &nbsp; &nbsp;~ ! @ | # $ % ^ & * + - _ = < > ? </h3>
          <br /><br />
        <button class="btn btn-large btn-primary" 
                type="submit" 
                name="btn-reset-pass">
            Reset Your Password
        </button>
        
      </form>

    </div> <!-- /container -->
  </body>
</html>