<?php
  session_start();
  require_once 'setup.php';

  $reg_user = new USER();

  // If already Logged-in Redirect to Home
    if($reg_user->is_logged_in()!="")
    {  $reg_user->redirect('home.php'); }

  // POST response for the SignUp button:
    if(isset($_POST['btn-signup']))
    {
        $uname = trim($_POST['txtuname'])    ;
        $email = trim($_POST['txtemail'])    ;
        $upass = trim($_POST['txtpass'])     ;
        $code  = md5(uniqid(rand()))         ;

        $PWtest = trim(checkPWord($upass))   ;

        if (!empty($PWtest))
        { $msg = $PWtest  ;
        }else
        {

            // Test input for a valid Email 
            if(is_email($email))
            {
                // Remove all illegal characters from email
                  $email = filter_var($email, FILTER_SANITIZE_EMAIL) ;

                try
                {
                      // Check if Email is in the Pool of available user-emails
                      $stmt  = $reg_user->runQuery("SELECT * FROM ".DB_VALIDTABLE." WHERE ".DB_MAILFIELD."=:email_id") ;
                        $stmt->execute(array(":email_id"=>$email)) ;
                        $row   = $stmt->fetch(PDO::FETCH_ASSOC)    ;
                   
                     if($stmt->rowCount() == 0)
                     { $msg = "<strong>Sorry!</strong>  This email is not currently authorized to register with ".$WelcomeTo ;
                     }else
                     {     
                        // Look for the new email among the emails already registered   
                        $stmt  = $reg_user->runQuery("SELECT * FROM ".DB_REG_USERS." WHERE ".DB_USER_EMAIL."=:email_id") ;
                            $stmt->execute(array(":email_id"=>$email))  ;
                            $row   = $stmt->fetch(PDO::FETCH_ASSOC)     ;
                       
                	      if($stmt->rowCount() > 0) // Email already in use
                	      { $msg = "<strong>Sorry !</strong>  That email is already Active.<br /> 
                                    Please Sign-In or try a different email." ;
                	      }else		// Email is available to use
                	      {
                  	        try  //  Try to Register with the DB and then Send and Email
                  	        {
                                $reg_user->register($uname,$email,$upass,$code);

                                $id   = $reg_user->lasdID() ;  
                                $key  = base64_encode($id)  ;
                                $id   = $key                ;
                                $jump = "signup"            ;

                                $subject = "Confirm Registration" ;

                                $message = "     
                                  Hello ".$uname.",
                                  <br /><br />
                                  Welcome to ".$WelcomeTo."!<br/>
                                  To complete your registration please, follow this link:<br/>
                                  <br /><br />
                                  <a href='".$MyDBLoginRoot."/springboard.php?id=".$id."&code=".$code."&jump=".$jump."'>Click HERE to Activate</a>
                                  <br /><br />
                                  Thanks," ;
                                
                                // Try to send the Verification Email                      
                                  try
                                  { $reg_user->send_mail($email,$message,$subject); 
                                    $msg = "We have sent an email to ".$email."<br />
                                            Please follow the link in the email to get to the New Password Tool." ;
                                  }
                                  catch(PDOException $ex)
                                  { $msg = "Sorry! It looks like we the confirmation email crashed.<br />".$retMailSent.
                                           "<br />".$ex->getMessage(); 
                                  }                       
                              }// if($stmt->rowCount() <> 0)  :: Already In Use
                              catch(PDOException $ex)
                              { $msg = "Registration with the server failed:  ". $ex->getMessage(); }                  
                        }// if($stmt->rowCount() <> 0)  :: currentTroopEmails
                      } //Email is on verified list of available emails
                }catch(PDOException $ex)
                { 
                  $msg = "Database read error: ".$ex->getMessage(); 
                }

            }else
            { //Not a Valid email:
                $msg = "<strong>Sorry!</strong>  The email you entered does not seem to be a valid format!<br />
                                                  Please try again." ;
            } 
        }
      }  


  function is_email($usermail)
  {
    //  If the username input string is an e-mail, return true
    //  longwinded for ease of reading.
      if(filter_var($usermail, FILTER_VALIDATE_EMAIL)) 
      { return true; } 
      else 
      { return false; }
  }  

  function checkPWord($pwd) 
  {
      $errors = "";
      $pattern = '/[\'\/~`\!@#\$%\^&\*\(\)_\-\+=\{\}\[\]\|;:"\<\>,\.\?\\\]/';

      if ( strlen($pwd) < 8)                  { $errors .= "Password too short! (Minimum of 8 Characters)<br />"         ; }
      if (!preg_match("#[0-9]+#", $pwd))      { $errors .= "Password must include at least one number!<br />"            ; }
      if (!preg_match("#[a-z]+#", $pwd))      { $errors .= "Password must include at least one Lower-Case letter!<br />" ; }
      if (!preg_match("#[A-Z]+#", $pwd))      { $errors .= "Password must include at least one Upper-Case letter!<br />" ; }  
      if (!preg_match($pattern,   $pwd))      { $errors .= "Password must include at least one Special Character!<br />" ; }    

      return trim($errors);
  }  
?>

<!DOCTYPE html>
<html>
  <head>
    <title>Credentials Request</title>
    <link rel="stylesheet"   href="login.css"  />
  </head>

  <body id="login">
    <div class="container">
      <form class="form-signin" method="post">
        <h1>Create New Site Login</h1>
          <div class="CommBox">
            <h3> <?php  if(isset($msg)) 
                        { echo $msg; 
                        }else{
                          echo "Your Email Must Already Be On File";
                        } ?>
            </h3>
          </div>

        <hr />

        <h2 class="form-signin-heading">Sign Up</h2>
          <hr />
        <input  type="email" 
                class="input-block-level" 
                placeholder="Email address" 
                name="txtemail" 
                required 
                size="75" /><br />
        <input  type="text" 
                class="input-block-level" 
                placeholder="Username" 
                name="txtuname" 
                required 
                size="25" /><br />              
        <input  type="password" 
                class="input-block-level" 
                placeholder="Password" 
                name="txtpass" 
                required
                size="25" /><br />
                <h3>Password Rules - at least 8 characters, Upper-Case & Lower-Case, and a <br />
                Special Character: &nbsp; &nbsp;~ ! @ | # $ % ^ & * + - _ = < > ? </h3>
        <hr />
          <br /><br />
          <button class="btn btn-large btn-primary" 
                type="submit" 
                name="btn-signup">
              Sign Up
          </button>
        <hr />        
        <br />
        Already Registered?<br />
        <h3><a href="index.php" class="btn btn-large">Sign In</a></h3>
        <br />
        <hr />
        <h3><a href="fpass.php"> Lost your Password ? </a></h3>        
      </form>

    </div> <!-- /container -->
  </body>
</html>